Index: common/i386/mc-a.asm
===================================================================
--- common/i386/mc-a.asm	(revision 346)
+++ common/i386/mc-a.asm	(working copy)
@@ -46,22 +46,6 @@
 %endmacro
 
 ;=============================================================================
-; Constants
-;=============================================================================
-
-%ifdef FORMAT_COFF
-SECTION .rodata data
-%else
-SECTION .rodata data align=16
-%endif
-
-ALIGN 16
-pw_4:  times 4 dw  4
-pw_8:  times 4 dw  8
-pw_32: times 4 dw 32
-pw_64: times 4 dw 64
-
-;=============================================================================
 ; Code
 ;=============================================================================
 
@@ -589,3 +573,20 @@
 .finish
     pop     edi
     ret
+
+;=============================================================================
+; Constants
+;=============================================================================
+
+%ifdef FORMAT_COFF
+SECTION .rodata data
+%else
+SECTION .rodata data align=16
+%endif
+
+ALIGN 16
+pw_4:  times 4 dw  4
+pw_8:  times 4 dw  8
+pw_32: times 4 dw 32
+pw_64: times 4 dw 64
+
Index: common/i386/deblock-a.asm
===================================================================
--- common/i386/deblock-a.asm	(revision 346)
+++ common/i386/deblock-a.asm	(working copy)
@@ -31,11 +31,6 @@
     %endif
 %endmacro
 
-SECTION .rodata align=16
-pb_01: times 16 db 0x01
-pb_3f: times 16 db 0x3f
-pb_ff: times 16 db 0xff
-
 SECTION .text
 cglobal x264_deblock_v8_luma_mmxext
 cglobal x264_deblock_h_luma_mmxext
@@ -525,3 +520,11 @@
     pop  ebp
     CHROMA_END
 
+;=============================================================================
+; Local Data (Read Only)
+;=============================================================================
+SECTION .rodata align=16
+pb_01: times 16 db 0x01
+pb_3f: times 16 db 0x3f
+pb_ff: times 16 db 0xff
+
Index: common/i386/dct-a.asm
===================================================================
--- common/i386/dct-a.asm	(revision 346)
+++ common/i386/dct-a.asm	(working copy)
@@ -124,31 +124,6 @@
 %endmacro
 
 ;=============================================================================
-; Local Data (Read Only)
-;=============================================================================
-
-%ifdef FORMAT_COFF
-SECTION .rodata data
-%else
-SECTION .rodata data align=16
-%endif
-
-;-----------------------------------------------------------------------------
-; Various memory constants (trigonometric values or rounding values)
-;-----------------------------------------------------------------------------
-
-ALIGN 16
-x264_mmx_1:        dw  1,  1,  1,  1
-x264_mmx_32:       dw 32, 32, 32, 32
-x264_mmx_PPNN:     dw  1,  1, -1, -1
-x264_mmx_PNPN:     dw  1, -1,  1, -1 
-x264_mmx_PNNP:     dw  1, -1, -1,  1 
-x264_mmx_PPPN:     dw  1,  1,  1, -1 
-x264_mmx_PPNP:     dw  1,  1, -1,  1 
-x264_mmx_2121:     dw  2,  1,  2,  1 
-x264_mmx_p2n2p1p1: dw  2, -2,  1,  1
-
-;=============================================================================
 ; Code
 ;=============================================================================
 
@@ -729,3 +704,28 @@
     %endrep
     ret
 
+;=============================================================================
+; Local Data (Read Only)
+;=============================================================================
+
+%ifdef FORMAT_COFF
+SECTION .rodata data
+%else
+SECTION .rodata data align=16
+%endif
+
+;-----------------------------------------------------------------------------
+; Various memory constants (trigonometric values or rounding values)
+;-----------------------------------------------------------------------------
+
+ALIGN 16
+x264_mmx_1:        dw  1,  1,  1,  1
+x264_mmx_32:       dw 32, 32, 32, 32
+x264_mmx_PPNN:     dw  1,  1, -1, -1
+x264_mmx_PNPN:     dw  1, -1,  1, -1 
+x264_mmx_PNNP:     dw  1, -1, -1,  1 
+x264_mmx_PPPN:     dw  1,  1,  1, -1 
+x264_mmx_PPNP:     dw  1,  1, -1,  1 
+x264_mmx_2121:     dw  2,  1,  2,  1 
+x264_mmx_p2n2p1p1: dw  2, -2,  1,  1
+
Index: common/i386/pixel-sse2.asm
===================================================================
--- common/i386/pixel-sse2.asm	(revision 346)
+++ common/i386/pixel-sse2.asm	(working copy)
@@ -36,15 +36,6 @@
 %endmacro
 
 
-%ifdef FORMAT_COFF
-SECTION .rodata data
-%else
-SECTION .rodata data align=16
-%endif
-
-pd_0000ffff: times 4 dd 0x0000ffff
-
-
 SECTION .text
 
 
@@ -531,3 +522,15 @@
 
     SATD_END
 
+;=============================================================================
+; Local Data (Read Only)
+;=============================================================================
+%ifdef FORMAT_COFF
+SECTION .rodata data
+%else
+SECTION .rodata data align=16
+%endif
+
+pd_0000ffff: times 4 dd 0x0000ffff
+
+
Index: common/i386/mc-a2.asm
===================================================================
--- common/i386/mc-a2.asm	(revision 346)
+++ common/i386/mc-a2.asm	(working copy)
@@ -33,22 +33,6 @@
     %endif
 %endmacro
 
-;=============================================================================
-; Read only data
-;=============================================================================
-
-SECTION .rodata data align=16
-
-ALIGN 16
-mmx_dw_one:
-    times 4 dw 16
-mmx_dd_one:
-    times 2 dd 512
-mmx_dw_20:
-    times 4 dw 20
-mmx_dw_5:
-    times 4 dw -5
-
 %assign twidth  0
 %assign theight 4
 %assign tdstp1  8
@@ -374,3 +358,20 @@
     pop         edi
 
     ret
+
+;=============================================================================
+; Read only data
+;=============================================================================
+
+SECTION .rodata data align=16
+
+ALIGN 16
+mmx_dw_one:
+    times 4 dw 16
+mmx_dd_one:
+    times 2 dd 512
+mmx_dw_20:
+    times 4 dw 20
+mmx_dw_5:
+    times 4 dw -5
+