diff -uNr libdvbpsi-svn-r149/configure.ac libdvbpsi-svn-r149-newversion/configure.ac
--- libdvbpsi-svn-r149/configure.ac	2007-10-11 19:31:04.000000000 +0200
+++ libdvbpsi-svn-r149-newversion/configure.ac	2007-10-11 19:31:31.000000000 +0200
@@ -4,7 +4,7 @@
 AC_CONFIG_AUX_DIR(autotools)
 AC_CANONICAL_SYSTEM
 
-AM_INIT_AUTOMAKE(libdvbpsi4, 0.1.6)
+AM_INIT_AUTOMAKE(libdvbpsi5, 0.1.6)
 AM_CONFIG_HEADER(config.h)
 
 #AC_CANONICAL_HOST
diff -uNr libdvbpsi-svn-r149/debian/control libdvbpsi-svn-r149-newversion/debian/control
--- libdvbpsi-svn-r149/debian/control	2007-10-11 19:31:03.000000000 +0200
+++ libdvbpsi-svn-r149-newversion/debian/control	2007-10-11 19:31:31.000000000 +0200
@@ -1,10 +1,10 @@
-Source: libdvbpsi4
+Source: libdvbpsi5
 Priority: optional
 Maintainer: Sam Hocevar (Debian packages) <sam+deb@zoy.org>
 Build-Depends: debhelper (>= 4.0)
 Standards-Version: 3.6.2.1
 
-Package: libdvbpsi4
+Package: libdvbpsi5
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}
@@ -12,17 +12,17 @@
  libdvbpsi is a simple library designed for MPEG TS and DVB PSI tables
  decoding and generating.
  .
- This package contains the libdvbpsi4 runtime library.
+ This package contains the libdvbpsi5 runtime library.
 
-Package: libdvbpsi4-dev
+Package: libdvbpsi5-dev
 Section: libdevel
 Architecture: any
-Depends: libdvbpsi4 (= ${Source-Version})
-Conflicts: libdvbpsi0-dev, libdvbpsi1-dev, libdvbpsi2-dev, libdvbpsi3-dev
-Description: development files for libdvbpsi4
+Depends: libdvbpsi5 (= ${Source-Version})
+Conflicts: libdvbpsi0-dev, libdvbpsi1-dev, libdvbpsi2-dev, libdvbpsi3-dev, libdvbpsi4-dev
+Description: development files for libdvbpsi5
  libdvbpsi is a simple library designed for MPEG TS and DVB PSI tables
  decoding and generating.
  .
  This package contains the header files and static library needed to
- compile applications that use libdvbpsi4.
+ compile applications that use libdvbpsi5.
 
diff -uNr libdvbpsi-svn-r149/debian/rules libdvbpsi-svn-r149-newversion/debian/rules
--- libdvbpsi-svn-r149/debian/rules	2007-10-11 19:31:03.000000000 +0200
+++ libdvbpsi-svn-r149-newversion/debian/rules	2007-10-11 19:31:31.000000000 +0200
@@ -45,15 +45,15 @@
 	dh_testdir
 	dh_testroot
 	dh_clean -k
-	dh_installdirs -plibdvbpsi4-dev usr/lib usr/share/doc
-	dh_installdirs -plibdvbpsi4 usr/lib usr/share/doc/libdvbpsi4
+	dh_installdirs -plibdvbpsi5-dev usr/lib usr/share/doc
+	dh_installdirs -plibdvbpsi5 usr/lib usr/share/doc/libdvbpsi5
 
-	$(MAKE) install DESTDIR=`pwd`/debian/libdvbpsi4/
+	$(MAKE) install DESTDIR=`pwd`/debian/libdvbpsi5/
 
-	ln -s libdvbpsi4 debian/libdvbpsi4-dev/usr/share/doc/libdvbpsi4-dev
-	mv debian/libdvbpsi4/usr/lib/*.so debian/libdvbpsi4/usr/lib/*a \
-		debian/libdvbpsi4-dev/usr/lib/
-	mv debian/libdvbpsi4/usr/include debian/libdvbpsi4-dev/usr/
+	ln -s libdvbpsi5 debian/libdvbpsi5-dev/usr/share/doc/libdvbpsi5-dev
+	mv debian/libdvbpsi5/usr/lib/*.so debian/libdvbpsi5/usr/lib/*a \
+		debian/libdvbpsi5-dev/usr/lib/
+	mv debian/libdvbpsi5/usr/include debian/libdvbpsi5-dev/usr/
 
 # Build architecture-independent files here.
 binary-indep: build install
diff -uNr libdvbpsi-svn-r149/libdvbpsi.spec libdvbpsi-svn-r149-newversion/libdvbpsi.spec
--- libdvbpsi-svn-r149/libdvbpsi.spec	2007-10-11 19:31:04.000000000 +0200
+++ libdvbpsi-svn-r149-newversion/libdvbpsi.spec	2007-10-11 19:31:31.000000000 +0200
@@ -1,8 +1,8 @@
 %define name		libdvbpsi
-%define version		0.1.5
+%define version		0.1.6
 %define release		1
 
-%define major		4
+%define major		5
 %define lib_name	%{name}%{major}
 
 %define redhat 0
diff -uNr libdvbpsi-svn-r149/src/Makefile.am libdvbpsi-svn-r149-newversion/src/Makefile.am
--- libdvbpsi-svn-r149/src/Makefile.am	2007-10-11 19:31:03.000000000 +0200
+++ libdvbpsi-svn-r149-newversion/src/Makefile.am	2007-10-11 19:31:48.000000000 +0200
@@ -11,7 +11,7 @@
                        $(tables_src) \
                        $(descriptors_src)
 
-libdvbpsi_la_LDFLAGS = -version-info 4:0:0
+libdvbpsi_la_LDFLAGS = -version-info 5:0:0
 
 pkginclude_HEADERS = dvbpsi.h psi.h descriptor.h demux.h \
                      tables/pat.h tables/pmt.h tables/sdt.h tables/eit.h \
diff -uNr libdvbpsi-svn-r149/wince/config.h libdvbpsi-svn-r149-newversion/wince/config.h
--- libdvbpsi-svn-r149/wince/config.h	2007-10-11 19:31:03.000000000 +0200
+++ libdvbpsi-svn-r149-newversion/wince/config.h	2007-10-11 19:31:31.000000000 +0200
@@ -57,7 +57,7 @@
 #define STDC_HEADERS 1
 
 /* Version number of package */
-#define VERSION "0.1.5"
+#define VERSION "0.1.6"
 
 /* C99 types */
 typedef unsigned char       uint8_t;